require({cache:{
'url:dojoe/gauge/valuestatus/templates/ValueStatusGauge.html':"<div id=\"${id}_valueStatusGauge\">\n\t<table role=\"presentation\" align=\"center\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\n\t\t<tr>\n\t\t\t<td colspan=\"2\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_topLabel\" data-dojo-attach-point=\"topLabelDiv\" align=\"center\" style=\"text-overflow: ellipsis\">\n\t\t\t\t</div>\n\t\t\t</td>\t\n\t\t</tr>\n\t\t<tr>\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\n\t\t\t\t</div>\n\t\t\t</td>\n\t\t\t<td data-dojo-attach-point=\"valueStatusGaugeTD\" style=\"padding: 0px\">\n\t\t\t\t<div id=\"${id}_valueStatusGaugeDiv\" data-dojo-attach-point=\"valueStatusGaugeDiv\" style=\"align:left\" >\n\t\t\t\t</div>\n\t\t\t</td>\n\t\t</tr>\n\t</table>\n</div>\n"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/gauge/valuestatus/ValueStatusGauge",[
		"dojo/_base/declare",
		"dojo/_base/connect",
		"dijit/_WidgetBase",
		"dijit/_TemplatedMixin",
		"dojo/text!./templates/ValueStatusGauge.html",
		"dojoe/BidiUtil",
		"dojoe/gauge/valuestatus/ValueStatusStyle",
		"dojoe/gauge/common/AbstractGauge",
		"dijit/Tooltip"
	],function(declare, connect, _WidgetBase, _TemplatedMixin, template, bidiUtil, ValueStyle, AbstractGauge, Tooltip) {
		return declare("dojoe.gauge.valuestatus.ValueStatusGauge", [_WidgetBase, _TemplatedMixin], {

		templateString: template,
		valueStatusGauge:null,
		
		// width: number  
		//		Holds the width of the Value Status Gauge. 
		width:100,
		
		// height: number  
		//		Holds the height of the Value Status Gauge. 
		height:100,
		
		// topLabel: String  
		//		Holds the String/label to be displayed on top of the Value Status Gauge
		topLabel:"",
		
		// leftLabel: String  
		//		Holds the String/label to be displayed on the leading edge the Value Status Gauge
		leftLabel:"",
		
		// value: Numeric  
		//		Holds the numeric value which the Value Status Gauge should represent.
		value:0,
		
		_labelRatio:0.25,
		_size:0,
		_labelSet:false,
				
		postCreate: function() {
			this.leftLabelDiv.style.textOverflow="ellipsis";
			this.inherited(arguments);
		},
		

		startup: function() {
			try{
				this.inherited(arguments);	
			}catch(err){
				console.debug(err);
			}
			
			

			this.valueStatusGauge = new dojoe.gauge.common.AbstractGauge({thresholds:this.thresholds, _currentValue:this._currentValue, dir:this.dir, styler:new ValueStyle()}, this.valueStatusGaugeTD.children[0]); //def58992
			//this.valueStatusGauge.styler = new ValueStyle();
			this.valueStatusGauge.styler.orient = this.valueStatusGauge.dir; //def58992
			this.valueStatusGauge.startup();
			
			var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
			var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 			
			this.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
			this.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
			this.valueStatusGauge.domNode.tabIndex = "0";
			console.log("ValueStatusGauge.js startup ends");
		},
		
		_showTooltip : function(arg) {
			var node;
			if(arg == "left"){
				node = this.leftLabelDiv;
				Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
			} else {
				node = this.topLabelDiv;
				Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
			}			
			setTimeout(function(){
				Tooltip.hide(node);
			}, 2000);
		},
		
		draw: function(surface){
			this.valueStatusGauge.adjust(surface);
		},
		
		resizeByScale: function(sx, sy, px, py){
			// summary:  
			//		Resizes the Value Status Gauge
			// sx: number
			//		 Ratio of original width and new width available
			// sy: number 
			//		Ratio of original Height and new height available
			// px: number 
			//		New width available
			// py: number 
			//		New height available
			// Do not add metric while specifying the numbers above
			// tags: public
			
			if(this.width == px && this.height == py) // same dimensions, no need to resize again.
				return;
			if(!this.leftLabel || this.leftLabel === undefined || this.leftLabel == "" ) {
				this._labelRatio = 0;
			} else {
				this._labelRatio = 0.25;
				this._labelSet = true;
			}

			//52965
			//this.width = this.width * sx;
			//this.height = this.height * sy;
			this.leftLabelTD.style.width = (px * this._labelRatio) + "px";
			this.leftLabelDiv.style.width=(px * this._labelRatio) + "px"; 
			this.width = px;
			this.height = py;
			var gfxWidth = px - this.leftLabelTD.offsetWidth - 4;
			var gfxHeight = py - this.topLabelTD.offsetHeight - 4;
			var min = gfxWidth < gfxHeight?gfxWidth:gfxHeight;
			//this.valueStatusGaugeDiv.style.width = this._size + "px";
			this.valueStatusGaugeDiv.style.position = "relative";
			this.valueStatusGauge._adjust({
				width:min, 
				height:min
			});
			//this.leftLabelTD.style.height = this._size + "px";
			if (this.dir == "rtl"){                                                                 //def58992
					this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";      //def58992
					this.topLabelDiv.style.marginLeft = "0px";                                      //def58992
			} else {                                                                                //def58992
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			} 
			//this.table.style.marginTop = (py- this.table.offsetHeight)/2 + "px"; // 52965
		},
		
		setLabelAndValue: function(topLabel, leftLabel, value) {
			// summary:  
			//		Sets labels and value for the Value Status Gauge
			// topLabel: String
			//		 Label which appears at the TOP of the gauge
			// leftLabel: String 
			//		Label which appears on the leading edge of the gauge
			// value: Numeric 
			//		Numeric Value to be displayed on the gauge
			// tags: public
			/*LS - avoid calling data apis in widget on object references
	    	 * 58511: TBSM 36702: Perf: Memory Leak in TWL status gauge*/
			/*if(topLabel && typeof(topLabel.getValueType) != "undefined" && topLabel.getValueType() == "status") {
				this.topLabel = topLabel.getValue().getValue();
			} else if(topLabel && typeof(topLabel.getValue) != "undefined") {
				this.topLabel = topLabel.getValue();
			} else
				this.topLabel = topLabel;
				
			if(leftLabel && typeof(leftLabel.getValueType) != "undefined" && leftLabel.getValueType()=="status")
				this.leftLabel = leftLabel.getValue().getValue();
			else if(leftLabel && typeof(leftLabel.getValue) != "undefined") {
				this.leftLabel = leftLabel.getValue();
			}else
				this.leftLabel = leftLabel;*/
			var oldLeftLabel = this.leftLabel;
			var oldTopLabel = this.topLabel;
			if(topLabel != "undefined" && topLabel != null)this.topLabel = topLabel;
	    	if(leftLabel != "undefined" && leftLabel != null)this.leftLabel = leftLabel;
	    	
	    	if(value && typeof value.getValue == 'function')
				value = value.getValue();
				
			if(value != "undefined" && value != null) this.value = value;
			// 52965
			var diffV = 0;
			if(this.leftLabel !== undefined && this.leftLabel !== "" && this.leftLabel !== null) {
				this._labelRatio = 0.25;
				this.leftLabelDiv.innerHTML = this.leftLabel;
				this.leftLabelDiv.title = this.leftLabel;
			} else {
				this._labelRatio = 0;
			}

			this.leftLabelTD.style.width = (this.width * this._labelRatio) + "px";
			this.leftLabelDiv.style.width= (this.width * this._labelRatio) + "px";
			if((this.width * this._labelRatio-4) > -1)
				this.leftLabelDiv.style.width=(this.width * this._labelRatio  - 4) + "px"; 
				
			if (this.dir == "rtl")                                   //def58992
				this.leftLabelDiv.style.textAlign = "left";          //def58992
			
			if(this.topLabel !== undefined && this.topLabel !== "" && this.topLabel !== null) {
				this.topLabelDiv.innerHTML = this.topLabel;
				
				this.topLabelDiv.title = this.topLabel;
				if (this.dir == "rtl"){                                                               //58992
					this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";        //58992
					this.topLabelDiv.style.marginLeft = "0px";                                        //58992
				} else {                                                                              //58992
					this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
				}
			}
			var diffH = this.leftLabelTD.offsetWidth + 4;
			diffV = this.topLabelTD.offsetHeight + 4;
			
			if((this.isTopCustomLabelSet && (oldTopLabel && this.topLabel) || (!oldTopLabel && !this.topLabel)) &&  (this.isLeftCustomLabelSet && (oldLeftLabel && this.leftLabel) || 
						(!oldLeftLabel && !this.leftLabel)))  {
				console.log("No need to call adjust from here as labels are present like before");
			} else {
				var min = (this.width - diffH) < (this.height - diffV) ? (this.width - diffH) : (this.height - diffV);
				//if((this._size - 15) > 0) {
						this.valueStatusGauge._adjust({
							width:min, 
							height:min
						});
					//}
				this.isLeftCustomLabelSet = true;
				this.isTopCustomLabelSet = true;
			}
			this.setValue(this.value);		
		},
		
		setValue: function(/*number*/ value){	
			if(value && typeof value.getValue == 'function')
				value = value.getValue();			
			this.valueStatusGauge.setValue(value);
			this.valueStatusGauge.domNode.title = value + " " + this.valueStatusGauge.styler.getStatus();
		},
	
		destroy: function(){
			// summary:
			//          Called when the widget is destroyed by dojo, used to clean 
			//          up memory before disassociating the widget from the dom.
			/*this.destroyWidgets();
			if(dojo.byId(this.id+"valueStatusGaugeDiv")) 
				dojo.forEach(dijit.findWidgets(dojo.byId(this.id+"valueStatusGaugeDiv")), function(widget){
				// Avoid double destroy of widgets like Menu that are attached to body
				// even though they are logically children of other widgets.
				if(widget && !widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});	*/
			this.topLabel= null;
			this.leftLabel=null;
			this.value=null;
			this.inherited(arguments);
		},
		
	/*	destroyWidgets: function() {
			try{
				if(this.gauge){
					var listWidget = dojo.byId(this.gauge);
					if(listWidget.destroyRecursive) listWidget.destroyRecursive();
					else if(listWidget.destroy) listWidget.destroy();
				}	
				
			} catch (ex) {
				console.error ("ValueStatusGauge.js: Caught exception in destroy:");
				console.error (ex);
			}
		}*/
});
});
