require({cache:{
'url:dojoe/gauge/volumebar/templates/VolumeBar.html':"<div id=\"${id}_volumeBar\">\r\n\t<table role=\"presentation\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\r\n\t\t<tr>\r\n\t\t\t<td colspan=\"3\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_topLabel\" data-dojo-attach-point=\"topLabelDiv\" align=\"left\" style=\"text-overflow: ellipsis\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"volumeBarTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div id=\"${id}_volumeBarDiv\" data-dojo-attach-point=\"volumeBarDiv\" style=\"align:left\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"volumeBarValueTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_volumeBarValue\" data-dojo-attach-point=\"volumeBarValue\" style=\"align:left;font-weight:bold\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/gauge/volumebar/VolumeBar", [
	"dojo/_base/declare",
	"dojo/_base/connect",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/VolumeBar.html",
	"dojoe/gauge/volumebar/VolumeBarStyle",
	"dojoe/gauge/common/AbstractGauge",
	"dojoe/BidiUtil",
	"dijit/Tooltip"
], function(declare, connect, _WidgetBase, _TemplatedMixin, template, VolumeBarStyle, AbstractGauge, bidiUtil, Tooltip) {
	return declare("dojoe.gauge.volumebar.VolumeBar", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		volumeBar:null,
		
		// width: number  
		//		Holds the width of the Analog Gauge. 
		width:120,
		
		// height: number  
		//		Holds the height of the Analog Gauge. 
		height:110,
		
		// topLabel: String  
		//		Holds the String/label to be displayed on top of the Analog Gauge
		topLabel:"",
		
		// leftLabel: String  
		//		Holds the String/label to be displayed on the leading edge the Analog Gauge
		leftLabel:"",
		
		// value: Numeric  
		//		Holds the numeric value which the Analog Gauge should represent.
		value:0,
		
		_labelRatio:0.20,
		_size:0,
		_leftLabelWidth:0,
		_valueWidth:0,
		
		postCreate: function() {
			this.leftLabelDiv.style.textOverflow="ellipsis";		
			this.inherited(arguments);
		},
		

		startup: function() {
			console.log("VolumeBar.js startup");
			try{
				this.inherited(arguments);	
			}catch(err){
				console.debug(err);
			}
			this.volumeBar = new dojoe.gauge.common.AbstractGauge({minValue:this.minValue, maxValue:this.maxValue, thresholds:this.thresholds, majorTickSeparation:this.majorTickSeparation, minorTickSeparation:this.minorTickSeparation, _currentValue:this._currentValue, dir:this.dir}, this.volumeBarDiv); //def58897
			this.volumeBar.styler = new VolumeBarStyle();
			this.volumeBar.styler.showThresholdStrip = this.showThresholdStrip;
			this.volumeBar.styler.orient = this.volumeBar.dir; //def58897
			this.volumeBar.startup();			
			var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
			var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 		
			this.volumeBarValue.style.whiteSpace="nowrap";
			dojo.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
			dojo.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
			this.volumeBar.domNode.tabIndex = "0";
			console.log("volumeBar.js startup ends");
		},
		
		_showTooltip : function(arg) {
			var node;
			if(arg == "left"){
				node = this.leftLabelDiv;
				Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
			} else {
				node = this.topLabelDiv;
				Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
			}			
			setTimeout(function(){
				Tooltip.hide(node);
			}, 2000);
		},
		
		draw: function(surface){
			this.volumeBar.adjust(surface);
		},
		
		resizeByScale: function(sx, sy, px, py, force){
			// summary:  
			//		Resizes the Analog Gauge
			// sx: number
			//		 Ratio of original width and new width available
			// sy: number 
			//		Ratio of original Height and new height available
			// px: number 
			//		New width available
			// py: number 
			//		New height available
			// Do not add metric while specifying the numbers above
			// tags: public
			
			if(this.width == px && this.height == py && sx != 0 && !force) { // same dimensions, no need to resize again. For abnormal scrolls in chrome 
																   // this method is called to remove them, sx condition is for that
				return;
			}
			if(this.leftLabel === undefined || this.leftLabel == "" ) {
				this._labelRatio = 0;
			} else {
				this._labelRatio = 0.2;
			}
			this.leftLabelTD.style.width = (px * this._labelRatio) + "px";	
			this.leftLabelDiv.style.width = (px * this._labelRatio) + "px";
			
			this.width = px;
			this.height = py;
			var gfxWidth = px - this.leftLabelTD.clientWidth - this.volumeBarValueTD.clientWidth - 1;
			if(dojo.isChrome)
				gfxWidth = gfxWidth - 9;
			var gfxHeight = py - this.topLabelTD.clientHeight - 1;
		
			//this.volumeBarDiv.style.width = this._size + "px";
			this.volumeBarDiv.style.position = "relative";
			
			this.volumeBar._adjust({
				width:gfxWidth, 
				height:gfxHeight
			});		
			
			//this.leftLabelTD.style.height = this._size + "px";
			//this.topLabelDiv.style.marginLeft = this._leftLabelWidth + 4 + "px";
			if (this.dir == "rtl"){                                                                 //def58897
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";       
				this.topLabelDiv.style.textAlign = "right";
			} else {                                                                                //def58897
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			}                                                                                       //def58897

			//this.table.style.marginTop = (py- this.table.offsetHeight)/2 + "px";
		},
		
		setLabelAndValue: function(topLabel, leftLabel, value) {
			// summary:  
			//		Sets labels and value for the Analog Gauge
			// topLabel: String
			//		 Label which appears at the TOP of the gauge
			// leftLabel: String 
			//		Label which appears on theleading edge of the gauge
			// value: Numeric 
			//		Numeric Value to be displayed on the gauge
			// tags: public
			/*if(topLabel && typeof(topLabel.getValueType) != "undefined" && topLabel.getValueType() == "status") {
				this.topLabel = topLabel.getValue().getValue();
			} else if(topLabel && typeof(topLabel.getValue) != "undefined") {
				this.topLabel = topLabel.getValue();
			} else
				this.topLabel = topLabel;
				
			if(leftLabel && typeof(leftLabel.getValueType) != "undefined" && leftLabel.getValueType()=="status")
				this.leftLabel = leftLabel.getValue().getValue();
			else if(leftLabel && typeof(leftLabel.getValue) != "undefined") {
				this.leftLabel = leftLabel.getValue();
			}else
				this.leftLabel = leftLabel;
			
			if(value && typeof(value.getValueType) != "undefined" && value.getValueType()=="status")
				this.value = value.getValue().getValue();
			else if(value && typeof(value.getValue) != "undefined") {
				this.value = value.getValue();
			}else
				this.value = value;*/
				
			var oldLeftLabel = this.leftLabel;
			var oldTopLabel = this.topLabel;
			
			if(topLabel != "undefined" && topLabel != null)this.topLabel = topLabel;
	    	if(leftLabel != "undefined" && leftLabel != null)this.leftLabel = leftLabel;
	    	if(value && typeof value.getValue == 'function')
				value = value.getValue();
	    	if(value != "undefined" && value != null)this.value = value;
	    	
	    	if(value && typeof value.getValue == 'function')
				this.value = value.getValue();
								
			if(this.leftLabel !== undefined && this.leftLabel !== "" && this.leftLabel != null) {
				this._labelRatio = 0.2;
				this.leftLabelDiv.innerHTML = this.leftLabel;
					
				this.leftLabelDiv.title = this.leftLabel;
				//this.leftLabelTD.style.height = this._size + "px";
			} else {
				this._labelRatio = 0;
			}
			
			if(this.topLabel !== undefined && this.topLabel !== "" && this.topLabel !== null) {
				this.topLabelDiv.innerHTML = this.topLabel;
					
				this.topLabelDiv.title = this.topLabel;			
			}
			this.setValue(this.value);
			this.leftLabelTD.style.width = (this.width * this._labelRatio) + "px";
			this.leftLabelDiv.style.width=(this.width * this._labelRatio) + "px"; 	
			if (this.dir == "rtl"){                                                             
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";      
				//this.topLabelDiv.style.marginLeft = "0px";           
				this.topLabelDiv.style.textAlign = "right";          
			} else {
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			}	
			//this._leftLabelWidth = (this.width * this._labelRatio);
			//this._valueWidth = this.volumeBarValueTD.clientWidth;
			//this.topLabelDiv.style.marginLeft = this._leftLabelWidth + 4 + "px";
			//this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			// chrome is behaving a little weird here. Even if the width is specified properly
			// as seen in debugger it just shows scroll(which aren't needed). if you click on portlet
			// it sends resize event with same width and height and scroll disappears, hence below fix.
			if(dojo.isChrome) {
				this.volumeBar.adjust({
					width:this.width - this.leftLabelTD.offsetWidth - this.volumeBarValueTD.offsetWidth - 25,
					height:this.height - this.topLabelTD.offsetHeight - 1
				});
				this.resizeByScale(0, 0, this.width, this.height, true);
			} else {
				if((this.isTopCustomLabelSet && (oldTopLabel && this.topLabel) || (!oldTopLabel && !this.topLabel)) &&  (this.isLeftCustomLabelSet && (oldLeftLabel && this.leftLabel) || 
						(!oldLeftLabel && !this.leftLabel)))  {
					console.log("No need to call adjust from here as labels are present like before");
				} else {
					this.volumeBar._adjust({
						width:this.width - this.leftLabelTD.offsetWidth - this.volumeBarValueTD.offsetWidth - 1,
						height:this.height - this.topLabelTD.offsetHeight - 1
					});
					this.isLeftCustomLabelSet = true;
					this.isTopCustomLabelSet = true;
				}
			}
			this.volumeBar.domNode.title = this.value + " " + this.volumeBar.styler.getStatus();
		},
		
		setValue: function(/*number*/ value){
			if(value && typeof value.getValue == 'function')
				value = value.getValue();
			this.volumeBar.setValue(value);
			this.volumeBarValue.innerHTML = value;
			this.volumeBar.domNode.title = value + " " + this.volumeBar.styler.getStatus();
		},
	
		destroy: function(){
			// summary:
			//          Called when the widget is destroyed by dojo, used to clean 
			//          up memory before disassociating the widget from the dom.
			this.destroyWidgets();
			if(dojo.byId(this.id+"volumeBarDiv")) dojo.forEach(dijit.findWidgets(dojo.byId(this.id+"volumeBarDiv")), function(widget){
				// Avoid double destroy of widgets like Menu that are attached to body
				// even though they are logically children of other widgets.
				if(widget && !widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});	
			this.inherited(arguments);
		},
		
		destroyWidgets: function() {
			try{
				if(this.gauge){
					var listWidget = dojo.byId(this.gauge);
					if(listWidget.destroyRecursive) listWidget.destroyRecursive();
					else if(listWidget.destroy) listWidget.destroy();
				}	
				
			} catch (ex) {
				console.error ("volumeBar.js: Caught exception in destroy:");
				console.error (ex);
			}
		}
});
});
