/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/list/_FilterBar", [
	"dojo/_base/declare",
	"dojo/_base/connect",
	"dojo/_base/lang",
	"dojo/cache",
	"dijit/_Widget",
	"dijit/_Templated",
	//"dijit/_TemplatedMixin",
	//"dijit/_WidgetsInTemplateMixin",
	"dojox/mobile/TabBar",
	"dojoe/list/_MultiSelectTabBarButton",
	"dojo/dom-style"
	], function(declare, connect, lang, cache, _Widget, _Templated, TabBar, MultiSelectTabBarButton, domStyle) {
		return declare("dojoe.list._FilterBar", [_Widget, _Templated], {
			templateString: cache("dojoe.list","templates/FilterBar.html"),
			widgetsInTemplate: true,
			iconBase: require.toUrl("dojoe/list/images/Status_filter_sprites.png"),
			fixed: "bottom",
			filtersForTabBarButton: null,
			filterEventListFunc: null,
			maxSeverity: 6, 
			filterBy:null,
			
			constructor: function() {
				this.filtersForTabBarButton = {};
			},
			postCreate: function() {
				this.inherited(arguments);
				for (i=0; i<=this.maxSeverity; i++){
					if ( this["filterButton"+i] ) { 
						domStyle.set(this["filterButton"+i].domNode,"float",(this.dir=="rtl"? "right" : "left"));
					}
				}
			},			
			filterEventListForButton: function() {
				// Filter events based on the selected tab bar buttons.
				var conditionString = "";
				var i = this.maxSeverity;
				while ( i >= 0 ) {
					if ( this["filterButton"+i] ) {
						var fb = this["filterButton"+i];
						if ( fb.selected ) {
							conditionString = this.filterBy+ "=" + i;
							this.filtersForTabBarButton["filterButton"+i] = conditionString;
						} else {
							//fb.deselect();
							delete this.filtersForTabBarButton["filterButton"+i];
						}
					}	
					i--;
				}
				var filterString = "";
				for(var i in this.filtersForTabBarButton) {
					if ( filterString === "" ) {
						filterString = this.filtersForTabBarButton[i];
					} else {
						filterString = filterString + " or " + this.filtersForTabBarButton[i];
					}
				}
				console.debug("====Condition string:"+filterString);

				this.filterEventListFunc(null, filterString);
			},
			updateTabBarButton: function(filterName, condition) {
    			// deselect All first
				var htmlElement = this["filterButton5"];;
    			if(htmlElement)htmlElement.deselectAll();
	
    			//if (filterName === "AllEvents:global") {
					if(condition.match(/=.*5/gi)){
	    				var htmlElement = this["filterButton5"];
            			if(htmlElement){
							htmlElement.select();
							this.filtersForTabBarButton[htmlElement.id] = this.filterBy+"=5";
						}
					} else if(condition.match(/=.*4/gi)){
	    				var htmlElement = this["filterButton4"];
            			if(htmlElement){
							htmlElement.select();
							this.filtersForTabBarButton[htmlElement.id] = this.filterBy+"=4";
						}
					} else if(condition.match(/=.*1/gi)){
	    				var htmlElement = this["filterButton1"];
            			if(htmlElement){
							htmlElement.select();
							this.filtersForTabBarButton[htmlElement.id] = this.filterBy+"=1";
						}
					} else if(condition.match(/=.*0/gi)){
	    				var htmlElement = this["filterButton0"];
            			if(htmlElement){
							htmlElement.select();
							this.filtersForTabBarButton[htmlElement.id] = this.filterBy+"=0";
						}
					}
					updateAllEventsCount();
    			//} else if (filterName === "BeijingFilter:global") {
    			//} else if (filterName === "LondonFilter:global") {
				//}
			},
			updateTabBarButtonCount: function(items) {
    			//if (!items || currentFilter === "AllEvents:global") return;
    			var sevBucket = {};
    			sevBucket["0"] = 0;
    			sevBucket["1"] = 0;
    			sevBucket["2"] = 0;
    			sevBucket["3"] = 0;
    			sevBucket["4"] = 0;
    			sevBucket["5"] = 0;
    			for(var i = 0; i < items.length; i++) {
					var sevValue = items[i].getProperty(this.filterBy).getValue();
					if(sevValue===null) sevValue="0";
 					if(sevBucket[sevValue]){
	    				sevBucket[sevValue]++;
					} else {
	    				sevBucket[sevValue] = 1;
					}
    			}
    			for(var s in sevBucket){
	   				var htmlElement = this["filter_button_"+s];
           			if(htmlElement)htmlElement._setLabelAttr(sevBucket[s]);
    			}
			},
			updateAllEventsCount: function() {
    			// trigger fetchData in Dashboard_Summary
			},
			
			destroy: function() {
				console.info("FilterBar.js: destroy BEGIN...");
				console.info("FilterBar.js id:"+this.id);
				console.debug(this.tabBar);
				if(this.tabBar){
					if(this.tabBar.destroyRecursive) this.tabBar.destroyRecursive();
					else if(this.tabBar.destroy) this.tabBar.destroy();
				}					
				this.inherited(arguments);
				console.debug(this.tabBar);
				console.info("FilterBar.js: destroy END...");
		   	}				
		});
	}
);
