require({cache:{
'url:dojoe/statusgauge/templates/StatusGauge.html':"<div id=\"${id}_statusGauge\">\r\n\t<table role=\"presentation\" align=\"center\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\r\n\t\t<tr>\r\n\t\t\t<td colspan=\"2\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_topLabel\" data-dojo-attach-point=\"topLabelDiv\" align=\"center\" style=\"text-overflow: ellipsis\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"statusGaugeTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_statusGaugeDiv\" data-dojo-attach-point=\"statusGaugeDiv\" style=\"align:left\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/

define("dojoe/statusgauge/StatusGauge", [
	"dojo/_base/declare",
	"dojo/_base/array",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/StatusGauge.html",
	"dojo/_base/connect",
	"dojoe/BidiUtil",
	"ibm/tivoli/navmodel/Dataset",
	"dijit/Tooltip"
],function(declare, array, _WidgetBase, _TemplatedMixin, template, connect, bidiUtil, Dataset, Tooltip) {
	return declare("dojoe.statusgauge.StatusGauge", [_WidgetBase, _TemplatedMixin], {
	
	templateString: template,
    width: 100,
    height: 100,
	topLabel:"",
	leftLabel:"",
	itemId:null,
	datasetInfo: null,
	_leftshift:0,
	_topshift:0,
	_s:1,
	thresholds: null,
	_labelRatio : 0.25,
	_size:0,
	_supportedStatuses:["informational","normal","minor","major","critical","fatal","undefined","unknown"],
	
	constructor: function(args){
		this.min = 0;
		this.max = 100;
        dojo.mixin(this, args);
	},
    
    startup: function(){
		this.draw();
		var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
		var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 			
		this.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
		this.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
    },
    
	_showTooltip : function(arg) {
		var node;
		if(arg == "left"){
			node = this.leftLabelDiv;
			Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
		} else {
			node = this.topLabelDiv;
			Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
		}			
		setTimeout(function(){
			Tooltip.hide(node);
		}, 2000);
	},
		
    setValue: function(v){
	      /*if(v != "undefined" && v.getValue){
			this.value = v.getValue();
	        } else	{
			this.value = v;
		}*/
		this.value = v;
        this.draw();
    },
	
	getValue: function(){
        return this.value;
    },
    
    setLabelAndValue: function(topLabel, leftLabel, value){
		/*if(topLabel && typeof(topLabel.getValueType) != "undefined" && topLabel.getValueType() == "status") {
			this.topLabel = topLabel.getValue().getValue();
		} else if (topLabel && typeof(topLabel.getValue) != "undefined"){
			this.topLabel = topLabel.getValue();
		} else
			this.topLabel = topLabel;
			

		if(leftLabel && typeof(leftLabel.getValueType) != "undefined" && leftLabel.getValueType()=="status")
			this.leftLabel = leftLabel.getValue().getValue();
		else if(leftLabel && typeof(leftLabel.getValue) != "undefined")
			this.leftLabel = leftLabel.getValue();
		else
			this.leftLabel = leftLabel;*/
    	/*LS - avoid calling data apis in widget on object references
    	 * 58511: TBSM 36702: Perf: Memory Leak in TWL status gauge*/
    	if(topLabel !== undefined && topLabel !== null && topLabel !== "") this.topLabel = topLabel;
    	if(leftLabel !== undefined && leftLabel !== null && leftLabel !== "") this.leftLabel = leftLabel;
		this.setValue(value);
    },
	   
    draw: function(){
		if(this.leftLabel !== undefined && this.leftLabel !== "" && this.leftLabel !== null) {
			this._labelRatio = 0.25;
			this.leftLabelDiv.innerHTML = this.leftLabel;
			this.leftLabelDiv.title = this.leftLabel;
			this.leftLabelDiv.style.direction = bidiUtil.getResolvedDir(this.leftLabel, this.textDir, this.dir);
			if (this.dir == "rtl"){
				this.leftLabelDiv.style.textAlign = "left";
			} else {
				this.leftLabelDiv.style.textAlign = "right";
			}
		} else {
			this._labelRatio = 0;
		}
		this.leftLabelTD.style.width = (this.width * this._labelRatio) + "px";
		//if((this.width * this._labelRatio-4) > -1)
		this.leftLabelDiv.style.width=(this.width * this._labelRatio) + "px"; 
		
		if(this.topLabel !== undefined && this.topLabel !== "" && this.topLabel !== null) {
			this.topLabelDiv.innerHTML = this.topLabel;
			this.topLabelDiv.title = this.topLabel;
			this.topLabelDiv.style.direction = bidiUtil.getResolvedDir(this.topLabel, this.textDir, this.dir);
			if (this.dir == "rtl"){
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";
				this.topLabelDiv.style.marginLeft = "0px";
			} else {
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
				this.topLabelDiv.style.marginRight = "0px";
			}
		}
		var diffH = (this.width * this._labelRatio) + 4;
		var diffV = this.topLabelTD.offsetHeight + 4;
		var min = (this.width - diffH) < (this.height - diffV) ? (this.width - diffH) : (this.height - diffV);
		//var min = (this.width - diffH - 8) < (this.height - diffV) ? (this.width - diffH - 8) : (this.height - diffV);
		var img = this._getStatusImage();
		if(img === undefined)
			return;
		if(dojo.isIE === undefined && dojo.isSafari === undefined) {
			//50317 : StatusGauge: onlick doesn't respond on SVG image
			// Hack to get onClick event work on the the SVG image. 
			//Image is overlayed with higher zIndex div which can absorb the onclick event.
			this.statusGaugeDiv.innerHTML = '<embed src=' + img + ' type="image/svg+xml" style="width:' + min + 'px;height:' + min + 'px"/>' +'<div style="width:' + min + 'px;height:' + min + 'px; top:-'+ min+  'px;position: relative; z-index: 1"/>';
			this.statusGaugeDiv.style.height = min + "px";
			this.statusGaugeDiv.style.overflow = "hidden";
		} else {
			this.statusGaugeDiv.innerHTML = '<img src=' + img + ' style="width:' + min + 'px;height:' + min + 'px"/>';
		}	
		
		//this.table.style.marginTop = (this.height - this.table.offsetHeight)/2 + "px";
		this.topLabelDiv.style.width = min + "px";	
    },

    resizeByScale: function(sx, sy, px, py){
    	if(px == this.width && py == this.height) { // same dimensions, no need to repaint.
    		return;
    	}
		this.width = px;
		this.height = py;
		this.draw();
    },
	
    _getStatusImage: function(){
		if(!this.value)
			return;
		var s;
		var ext;
		var image;
		var imageFound = true;
		//if(this.value && this.value.getValueType() == "status") {
		if(this.value && typeof(this.value.getValue) != "undefined") {
			image = this.value.getImage();	
			var scalarImage = this.value.getScalarImage();		
			scalarImage = scalarImage.substr(scalarImage.lastIndexOf("_") + 1);
			scalarImage = scalarImage.substr(0, (scalarImage.length - 4));
			if(scalarImage == "warning" || scalarImage == "WarningMinor" || scalarImage=="warning_minor")
				scalarImage="minor";
			else if(scalarImage == "WarningMajor" || scalarImage=="warning_major") 
				scalarImage="major";
				
			if(array.indexOf(this._supportedStatuses, scalarImage) > -1) {
				s={};
				s["status"]=scalarImage;
			} else {
				if(image && image.indexOf('[widget]') > -1){
					image = image.replace('[widget]', "ibm/tivoli/tip/navwidget/themes");
					image = require.toUrl(image);
					imageFound = false;
				}	
			}
			//_supportedStatuses
		} else {
			s = this.getThresholdFromValue(this.value, this.thresholds);
		}	
		this.statusGaugeDiv.title = s.status;
		if(!imageFound)
			return image;
		ext = ".png";
		console.log("dojo.isIE - " + dojo.isIE);
		if(dojo.isIE === undefined)
			ext = ".svg";
		// images are symmetric, need nt be inverted. 'Normal' img is not(symmetric) but displayed in same way in rtl languages
        /*if (this.dir == "rtl"){
        	return dojo.moduleUrl("dojoe.statusgauge.StatusStyle", s.status.toLowerCase() + '_rtl' + ext);
        }*/
        return dojo.moduleUrl("dojoe.statusgauge.StatusStyle", s.status.toLowerCase() + ext);
    },
    
    getThresholdFromValue: function(value, thresholds){
        // summary:
        //          Returns the threshold from the sorted array that the value 
        //          resides within.
        // value: Number
        //          Value to find the threshold for.
        // thresholds: Array
        //          Sorted array of thresholds, sorted by their "start" 
        //          attribute.
        // returns:
        //          The threshold from the array where the value resides, or 
        //          thresholds[0] if can't find it anywhere...
        
		if(value === undefined)
			return {name: "Unknown", status: "Unknown", start: 0};
		
        if (thresholds.length==0) 
              return {name: "Undefined", status: "Undefined", start: 0};

		if(this.value !== undefined && this.value.getValue)
				value = this.value.getValue();
				
		for(var i = 0, len = thresholds.length; i < len; i++){
            if(i == len-1){
                if(value < thresholds[i].start){
                    return thresholds[0];
                } else {
                    return thresholds[i];
                }
            }
            if(value >= thresholds[i].start && value < thresholds[i+1].start){
                return thresholds[i];
            }
        }

		return thresholds[0];
    },
    
    destroy: function(){
		// summary:
		//          Called when the widget is destroyed by dojo, used to clean 
		//          up memory before disassociating the widget from the dom.
		
		this.topLabel= null;
		this.leftLabel=null;
		this.value=null;
		this.inherited(arguments);
	}
	
});
});
