// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivwizard_pages/SubstepSelect", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivSubstep,dijit/form/MultiSelect"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.tests.tivwizard_pages.SubstepSelect");

dojo.require("ibm.tivoli.tip.dijit.TivSubstep");
dojo.require("dijit.form.MultiSelect");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivwizard_pages.SubstepSelect", [ibm.tivoli.tip.dijit.TivSubstep], 
{
  templateString:"<div class=\"substepselect\">\r\n  <div class=\"tiv-page-header\">\r\n    <h2>Select Item</h2>\r\n    <p>Second substep in loop. Select an item and then press OK to go back to the main step and\r\n    see the item added to the buy list.  To get out of the loop and get to Page 8, press the Next\r\n    button.  To go back to the previous substep, press the Cancel button.\r\n    </p>\r\n  </div>\r\n  <div class=\"tiv-page-content\">\r\n    <h4>Select an item:</h4>\r\n    <div dojoType=\"dijit.form.MultiSelect\" dojoAttachPoint=\"_selectAnItem\" style=\"width:300px;height:100px\"></div>\r\n    <div style=\"margin-top:3em;\">\r\n      <input type=\"button\" dojoAttachPoint=\"_okButton\" value=\"OK\" />\r\n      <input type=\"button\" dojoAttachPoint=\"_cancelButton\" value=\"Cancel\" />\r\n    </div>\r\n  </div>\r\n</div>\r\n",
  title: "Select Item",
  
  items: [ ["79847 - Single Sided Business Card", "79847D - Double Sided Business Card", 
                  "79847B - Braille Business Card"], 
           ["9014 - Basket of Daises", "9088 - New Baby Flowers", "9045 - Sympathy Flowers"],
           ["254C - Canon Printer", "255H - HP Printer", "256L - Lexmark Printer" ] ],
  
  postCreate: function()
  {
    dojo.connect(this._okButton, "onclick", this, this.onOK);
    dojo.connect(this._cancelButton, "onclick", this, this.onCancel);
  },   

  OnPageSelected: function() 
  {
    var selectBox = this._selectAnItem.domNode;

    // clear select box contents
    var options = selectBox.options;
    for (i=options.length-1; i>=0; i--)
       selectBox.remove(i);
    
    // retrieve selection criteria from previous substep
    var itemType;
    var findPage = dijit.getEnclosingWidget(dojo.query(".substepfind", this.wizard.domNode)[0]);    
    if (findPage != null) {
      itemType = findPage._itemType.selectedIndex;
      
      // get all items that match
      var matches = this.items[itemType];

      // create option node and add to select box
      var n=0;
      dojo.forEach(matches, function(item) {
        var c = document.createElement('option');
        c.text = item;
        c.value = "" + n++;
        selectBox.options.add(c);       
      }, this);
      
      // select first one
      selectBox.selectedIndex = 0;
    }
  },
  
  onOK: function()
  {
    // get main page
    var mainPage = dijit.getEnclosingWidget(dojo.query(".page8", this.wizard.domNode)[0]);
    if (mainPage != null) {
      // add selected items to list on main page
      var contents = mainPage._itemList.value;
      
      // will be at least one selected
      dojo.forEach(this._selectAnItem.getSelected(), function(opt) {
        contents += opt.innerHTML + "\n"; 
      });      
      mainPage._itemList.value = contents;
      
      // mark as visited
      this.visited = true;
      
      // jump back to main page
      // (can be done by either function below)
      //this.wizard.jumpBackToPage(mainPage);
      this.wizard.jumpToNextLoopStep();    
    }
  },
  
  onCancel: function()
  {
    this.wizard.jumpToPreviousLoopStep();
  }  
});

});
