// wrapped by build app
define("ibm/tivoli/tip/navwidget/dojo/NavWidgetBaseViewState", ["dijit","dojo","dojox","dojo/require!dojox/collections/Dictionary"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState");

dojo.require("dojox.collections.Dictionary");

dojo.declare(
    "ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState",
    null,
    {		
  		dataset: null,
    	stateData: null,
  		_viewStates: null,
  		
  		constructor: function(kwArgs) {
			//Look at kwArgs
    		if (kwArgs) {
    			this.view = kwArgs.view;
				this.dataset = kwArgs.dataset;		
				this.stateData = kwArgs.stateData;
			}
		
    		//Create internal data structure for states
    		this._viewStates = new dojox.collections.Dictionary();
	 	},
	 	
	 	addPluggableViewState: function(viewId, viewState) {
			this._viewStates.add(viewId, viewState);
		},

		getPluggableViewState: function(viewId) {
			return this._viewStates.item(viewId);
		},
		
		removePluggableViewState: function(viewId) {
			return this._viewStates.remove(viewId);
		},
		
		destroy: function() {
			this.dataset = null;
			this.stateData = null;
			if (this._viewStates) {
				this._viewStates.clear();
				this._viewStates = null;
			}
		}
    }
);
});
