// wrapped by build app
define("ibm/tivoli/tip/trace/Trace", ["dijit","dojo","dojox"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.trace.Trace");

/** 
 * The Trace class. 
 *
 * @author: Marco Lerro (marco.lerro@it.ibm.com)    
 */
dojo.declare(
    "ibm.tivoli.tip.trace.Trace",
    [],
    {
        /** the trace name */
        traceName: "",
        
        constructor: function(name)
        {
        	/** the trace name */
        	this.traceName = name;
        },
        
    	info: function(dbgString)
    	{
    		this.trace("INFO", this.traceName, dbgString);
    	},
    	
        object: function(dbgObject)
    	{
    		this.trace("INFO", this.traceName, dojo.toJson(dbgObject));
    	},
    	
	    warn: function(dbgString)
    	{
    		this.trace("WARN", this.traceName, dbgString);
    	},
    	
	    assert: function(predicate, message)
        {
            if ( predicate === false ) {
                this.trace("WARN", this.traceName, "assertion failed: " + message);
		    }		
	    },
	    
	    error: function(dbgString)
	    {
            if (dbgString && dbgString instanceof Error) {
                this.trace("EXCEPTION", this.traceName, dbgString.toString());
	    	} else {
                this.trace("ERROR", this.traceName, dbgString);
	    	}
	    },
	    
	    trace: function(level, traceName, message)
	    {
	        console.debug(level + " " + traceName + " " + message);
	    }
    }
);


});
