require({cache:{
'url:ibm/usmi/core/framework/templates/ContentTitle.html':"<div data-dojo-attach-point=\"titleContainer\" class=\"contentTitleContainer\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<span class=\"contentTitle\"></span>\r\n\t<span class=\"contentStatus\"></span>\r\n</div>\r\n"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/core/framework/ContentTitle", [
	"require",
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/ContentTitle.html",
	"dojo/_base/lang",
	"dojo/topic",
	"dojo/query"
], function (require, dojo, declare, WidgetBase, TemplatedMixin, template, lang, topic, query) {
	return declare([
		WidgetBase,
		TemplatedMixin
	], {

		// Path to the template
		templateString : template,

		baseClass : "contentTitle",

		productName : "product name",

		masterEnabled : false,

		constructor : function (args) {
			dojo.safeMixin(this, args);
		},

		postCreate : function () {
			this.inherited(arguments);

			topic.subscribe("updateTitle", lang.hitch(this, this.updateTitle));
			topic.subscribe("reTarget", lang.hitch(this, this.reTarget));
			topic.subscribe("TITLE_MASTER", lang.hitch(this, this._setTitleMasterEnabled));
		},

		_setTitleMasterEnabled : function (enabled) {
			this.masterEnabled = enabled;
		},

		updateTitle : function (subtitles) {
			var title;
			if(this.masterEnabled ) {
				if(subtitles.titleMaster) {
					if (subtitles.resource) {
						title = subtitles.resource;
					}
					if (subtitles.view) {
						if (title) {
							title += ": ";
						} else {
							title = "";
						}
						title += subtitles.view;
					}

					var titleContainer = this.get("titleContainer");
					var titleElement = query(".contentTitle", titleContainer);
					titleElement[0].innerHTML = title;
					document.title = title + " - " + this.productName;

					var status = "";
					if (subtitles.loading) {
						status = "(loading)";
					}
					titleElement = query(".contentStatus", titleContainer);
					titleElement[0].innerHTML = status;
				}
			} else {
				if (subtitles.resource) {
					title = subtitles.resource;
				}
				if (subtitles.view) {
					if (title) {
						title += ": ";
					} else {
						title = "";
					}
					title += subtitles.view;
				}

				var titleContainer = this.get("titleContainer");
				var titleElement = query(".contentTitle", titleContainer);
				titleElement[0].innerHTML = title;
				document.title = title + " - " + this.productName;

				var status = "";
				if (subtitles.loading) {
					status = "(loading)";
				}
				titleElement = query(".contentStatus", titleContainer);
				titleElement[0].innerHTML = status;
			}
		},

		reTarget : function (dataset) {
			var title = dataset._dataset.label; // need way to get title w/o using private - Aaron?
			this.updateTitle({
				resource : title
			});
		}
	});
});
