require({cache:{
'url:ibm/usmi/dashboard/templates/ResourceGroupWidget.html':"<div class=\"dashboard-group-component\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div id=\"groupPod\" data-dojo-attach-point=\"groupPod\">\r\n\t\t<div data-dojo-attach-point=\"image\" role=\"button\"></div>\r\n\t\t<div data-dojo-attach-point=\"footer\">\r\n\t\t\t<span data-dojo-attach-point=\"status\"></span>\r\n\t\t\t<span data-dojo-attach-point=\"label\" role=\"button\" class=\"dashboard-head-componentLabel\">\r\n\t\t\t</span>\r\n\t\t</div>\r\n\t</div>\r\n</div>\r\n"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/dashboard/ResourceGroupWidget", [
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/ResourceGroupWidget.html",
	"dijit/_WidgetsInTemplateMixin",
	"./Constants",
	"dojo/_base/connect",
	"dojo/_base/lang",
	"dojo/hash",
	"dojo/io-query",
	"dojo/DeferredList",
	"ibm/usmi/core/utils/Logger"
], function (dojo, declare, WidgetBase, TemplatedMixin, template, WidgetsInTemplateMixin, Constants,
		connect, lang, hash, ioQuery, DeferredList, Logger) {
	return declare([
		WidgetBase,
		TemplatedMixin,
		WidgetsInTemplateMixin
	], {
		templateString : template,

		resourceGroup : null,

		//Subscriptions to clean up
		hashSubscription : null,
		hoverSubscription : null,
		
		// status class array
		_statusIconClass : {
			0 : "sprite dashboardErrorIcon",
			1 : "sprite dashboardWarningIcon",
			6 : "sprite normalIcon",
			5 : "sprite unknownIcon"
		},

		resourceImageFocus : true,
		
        // the logger
        _resourceGroupWidgetLogger : new Logger("ibm.usmi.dashboard", "ResourceGroupWidget"),

		/**
		 * Set up the component. Listen for mouse and keyboard events. Set the
		 * label to display an unknown amount of this component.
		 */
		postCreate : function () {
			this.inherited(arguments);
			this.resourceGroup.normalImage = this.resourceGroup.name + "Icon";
			this.connect(this.groupPod, "onmouseenter", "_onFocus");
			this.connect(this.groupPod, "onmouseleave", "_onBlur");
			this.connect(this.groupPod, "onblur", "_onBlur");
			this.connect(this.groupPod, "onfocus", "_onFocus");
			this.connect(this.groupPod, "onclick", "_onSelect");
			this.set("footerContentCount", this.resourceGroup.loadingLabel);
			this.hashSubscription = connect.subscribe("/dojo/hashchange", this, this.updateSelection);
			if (this.resourceGroup.selected) {
				this.set("imageClass", this.resourceGroup.normalImage + "Selected");
			} else {
				this.set("imageClass", this.resourceGroup.normalImage);
			}

		},

		/**
		 * Update the icon as not selected if other group's was selected.
		 */
		updateSelection : function (hashStr) {
			var hashObj = ioQuery.queryToObject(hashStr), selectedGroup = hashObj.selectedGroup;
			if (!selectedGroup) {
				if (this._resourceGroupWidgetLogger.isFinest()) {
					this._resourceGroupWidgetLogger.entering("selectedGroup not specified", "updateSelection");
				}
				return;
			}
			if (selectedGroup === this.resourceGroup.name && this.resourceGroup.selected) {
				//already selected for this component
				return;
			}

			if (selectedGroup === this.resourceGroup.name) {
				//this group is not selected yet
				this.resourceGroup.selected = true;
				this.set("imageClass", this.resourceGroup.normalImage + this.getStatusString() + "Selected");
			} else {
				//the selection has been changed
				this.resourceGroup.selected = false;
				try {
					this.set("imageClass", this.resourceGroup.normalImage + this.getStatusString());
				} catch (error) {
					if (this._resourceGroupWidgetLogger.isError()) {
						this._resourceGroupWidgetLogger.error("Setting imageClass failed:  "
								+ error, "updateSelection");
					} 
				}
			}
		},

		/**
		 * Set the height of this component to be the height of the image plus
		 * the height of the label. Needed to stop this component from taking up
		 * too much room on the page.
		 */
		resize : function () {
			if (this._resourceGroupWidgetLogger.isFinest()) {
				this._resourceGroupWidgetLogger.finest("resize group widget " + this.resourceGroup.name, "resize");
			}

			this.inherited(arguments);
			//dojo.style(this.containerNode, "height", (dojo.marginBox(this.image).h + dojo.marginBox(this.footer).h) + "px");
			//dojo.style(this.containerNode, "width", dojo.marginBox(this.image).w + "px");
		},

		/**
		 * Update the Dashbar icon with the current status.
		 */
		loadInitialStatus : function (totalNumber) {
			//initially load it as unknown
			if (this.resourceGroup.selected) {
				this.set("imageClass", this.resourceGroup.normalImage + "Unknown" + "Selected");			
			} else {
				this.set("imageClass", this.resourceGroup.normalImage + "Unknown");
			}
			this.set("footerContentCount", totalNumber);
			
		},
		
		getStatusString : function () {
			var statusString = "";
			if (this.resourceGroup.getGroupStatusValue() === 0) {
				statusString = "Critical";
			}
			else if (this.resourceGroup.getGroupStatusValue() === 1) {
				statusString = "Warning";	
			}
			else if (this.resourceGroup.getGroupStatusValue() === 5) {
				statusString = "Unknown";	
			}
			return statusString; 
		},
		
		/**
		 * Update the footer's status icon.
		 */
		updateStatus : function (status) {
			this.resourceGroup.setGroupStatus(status);
			//this.set("footerContent", status.getValue(), this.resourceGroup.getGroupCount());
			this.set("footerContentStatus", status.getValue());
		},
		
		/**
		 * Update the footer's total group item count number.
		 */
		updateCount : function (totalNumber) {
			this.set("footerContentCount", totalNumber);
			//this.set("footerContent", this.resourceGroup.getGroupStatusValue(), totalNumber);
		},

		/**
		 * Getter for the class used by this component's image. This method is
		 * called when this component gets and loses focus.
		 */
		_getImageClassAttr : function () {
			return this.image.className;
		},

		/**
		 * Setter for the class used by this component's image. This method is
		 * called when this component gets and loses focus.
		 */
		_setImageClassAttr : function (className) {
			this.image.className = className;
		},
		
		/**
		 * Setter to change this components status icon and text in the label.
		 * This is used when this component gets a result update from the back
		 * end. The status us set to the worst status in the results.
		 * 
		 * @param status
		 *            {String} key for the _statusIconClass map
		 */
		_setFooterContentStatusAttr : function (status) {
			if (!status && status !== 0) {
				// 5 is unknown
				status = 5;
			}
			
			var statusStr = "";
			if (status === 0) {
				statusStr = "Critical";
			}
			else if (status === 1) {
				statusStr = "Warning";
			}
			else if (status === 5) {
				statusStr = "Unknown";
			}
			
			if (this.resourceGroup.selected) {
				this.set("imageClass", this.resourceGroup.normalImage + statusStr + "Selected");			
			} else {
				this.set("imageClass", this.resourceGroup.normalImage + statusStr);
			}				
		},
		
		/**
		 * Setter to change this components status icon and text in the label.
		 * This is used when this component gets a result update from the back
		 * end. The status us set to the worst status in the results.
		 * 
		 * @param total
		 *            {String} the number or "?" to append indicating the number
		 *            of entities represented by the component
		 */
		_setFooterContentCountAttr : function (total) {

			total = total || 0;

			// abbreviate the label if necessary to make sure it doesn't go over the width of the footer
			var countText = " (" + total + ")";
			this.label.innerHTML = this.resourceGroup.label + countText;
		},

		/**
		 * Listener method for when this component receives focus. Set the class
		 * name of the main image to a hover class.
		 */
		_onFocus : function () {
			// tab events come in multiple times, so check if we already have focus
			// before setting the image
			connect.publish(Constants.resourceGroupHoved, this.resourceGroup.name);
			this.resourceImageFocus = true;
			if (this.get("imageClass").indexOf("Hover") === -1) {
				this.set("imageClass", this.resourceGroup.normalImage + this.getStatusString() + "Hover");
			}
		},

		/**
		 * Listener method for when this component loses focus. Set the class
		 * name of the main image to a non-hover class.
		 */
		_onBlur : function () {
			if (this.resourceGroup.selected) {
				return;
			}
			this.set("imageClass", this.resourceGroup.normalImage + this.getStatusString());
		},

		/**
		 * Listener method for when this component has been clicked on. Launches
		 * the table specified by the "tableName"
		 */
		_onSelect : function () {
			var refreshFlag = false;
			if (this.resourceGroup.selected === true) {
				refreshFlag = true;
			}
			this.resourceGroup.selected = true;
			if (this.get("imageClass").indexOf("Selected") === -1) {
				this.set("imageClass", this.resourceGroup.normalImage + this.getStatusString() + "Selected");
			}
			//connect.publish(Constants.resourceGroupSelected, this.name);
			var hashObj = ioQuery.queryToObject(hash());
			hashObj.selectedGroup = this.resourceGroup.name;
			
			// check to see if treeTopperId is set in hash, if so remove
			if (hashObj['treeTopperId']) {
				delete hashObj.treeTopperId;
			}

			var hashStr = ioQuery.objectToQuery(hashObj);
			hash(hashStr, true);

			if (refreshFlag) {
				//if it's clicked again, publish refresh message
				connect.publish(Constants.resourceGroupSelected, this.resourceGroup.name);
			}

		},

		getResourceGroupGroupOID : function () {
			return this.resourceGroup.getGroupOID();
		},
		
		/*
		 * load data from the backend
		 */
		loadSystemStatus : function () {
			if (this._resourceGroupWidgetLogger.isFinest()) {
				this._resourceGroupWidgetLogger.finest("loading system status for group " + this.resourceGroup.name, "loadSystemStatus");
			}

			var count = this.resourceGroup.getGroupCount();
			this.loadInitialStatus(count);
		},
		


		destroy : function () {
			if (this.hashSubscription) {
				this.hashSubscription.remove();
				this.hashSubscription = null;
			}
			if (this.hoverSubscription) {
				this.hoverSubscription.remove();
				this.hoverSubscription = null;
			}
			this.inherited(arguments);
		},
		destroyRecursive : function () {
			this.inherited(arguments);
		}

	});

});
