/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/menus/Menu", [
	"require",
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dojo/_base/lang",
	"idx/oneui/MenuBar",
	"ibm/usmi/statuspod/AlertStatusPod",
	"ibm/usmi/statuspod/JobStatusPod",
	"dijit/MenuBarItem"
], function (require, dojo, declare, WidgetBase, lang, MenuBar, AlertStatusPod,
		JobStatusPod, MenuBarItem) {
	return declare([
		WidgetBase,
		MenuBar
	], {

		showProblemStatusPod : false,

		showJobStatusPod : false,
		
		//Contains the information for the user menu with fields "displayName" for the user's
		//name and "menu" for the popup menu
		userMenu : null,
		
		helpMenu : null,

		baseClass : "menus.Menu",

		constructor : function (args) {
			dojo.safeMixin(this, args);

		},

		postCreate : function () {
			this.inherited(arguments);
			if (this.showProblemStatusPod) {
				var problemMenuBarItem = new AlertStatusPod({
					id : "alertStatusPod"
				});
				this.addChild(problemMenuBarItem);
			}
			if (this.showJobStatusPod) {
				var jobMenuBarItem = new JobStatusPod({
					id : "jobStatusPod"
				});
				this.addChild(jobMenuBarItem);
			}
			if (this.userMenu) {
				this.addChild(new MenuBarItem({ label : "<span class='idxHeaderUserMenuBarItemLabel'></span>" + this.userMenu.displayName, popup: this.userMenu.menu}));
			}
			if (this.helpMenu) {
				
				this.addChild(new MenuBarItem({ label : "<span class='idxHeaderHelpIcon'></span>", popup: this.helpMenu}));
			}
		}
	});
});
