/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/nls/frameworkResources", {
    root: {
	//Finder Resources BEGIN
	FinderInitialText : "Find a System or Task",
	NoTasksFound : "(no tasks found)",
	NoGroupsFound : "(no groups found)",
	NoResourcesFound : "(no resources found)",
	Close : "Close dialog.",
	RefreshCache : "Refreshed {0} {1} ago. Refresh to include newly added/modified resources in results.",
	Minutes : "minute(s)",
	Hours : "hour(s)",
	Days : "day(s)",
	Searching0 : "Searching.",
	Searching1 : "Searching..",
	Searching2 : "Searching...",
	FinderRefreshing : "Refreshing...",
	MoreTasks : "Refine your search terms for more results.",
	MoreResources : "Show all.",
	MoreGroups : "Refine your search terms for more results.",
	FinderTaskMenu : "Tasks",
	FinderResourceMenu : "Resources",
	FinderGroupMenu : "Groups",
	Chassis : "Chassis",
	Resources : "Resources",
	FinderTooltipHelp : "Use this inline finder to search for all tasks and managed resources.",
	//tooltip
	FinderTooltipClickResources : "Click on this resource to view more details",
	FinderTooltipClickTask : "Clicking here will open a new browser window and launch this task.",
	FinderTooltipClickJob : "Click here to schedule this job.",
	FinderTooltipClickUrl : "Clicking here will open a new browser window and load this url.",
	FinderTooltipClickPage : "Click here to open this page.",
	FinderTooltipClickDialog : "Click here to open this dialog.",
	FinderTooltipClickGroup : "Click on this group to view its members",
	FinderTooltipEntryType : "{0}: ",
	FinderTooltipCategory : "Category: ",
	FinderTooltipExternalTask : "External Task: ",
	FinderTooltipJob : "Job: ",
	FinderTooltipUrl : "Url: ",
	FinderTooltipPage : "Page: ",
	FinderTooltipDialog : "Dialog: ",
	FinderTooltipTaskDescription : "Description: ",
	SelectedResources : "{0} selected resources :",
	SelectedResource : "'{0}':",
	SelectedResourceText : "Contextual Tasks for {0}",
	GlobalTasksText : "Global Tasks : ",

	//Finder Resources END

	// Mega Menu Resources BEGIN
	Home : "Home",
	Dashboards : "Dashboards",
	GettingStarted : "Getting Started",
	InitialSetup : "Initial Setup",
	FlexExplorer : "Flex Explorer",
	QuickStartGuides : "Quick Start Guides",
	SummaryPages : "Summary Pages",
	VMControl : "VMControl",
	StorageControl : "Storage Control",
	NetworkControl : "Network Control",
	ServiceAndSupport : "Service and Support",
	CheckForUpdates : "IBM&reg; FSM - Check for Updates",
	Systems : "Systems",
	SystemsMenuHeading : "Systems",
	AllGroups : "All Groups",
	AllOSs : "All OSs",
	PowerSystemsManagement : "Power Systems Management",
	Configuration : "Configuration",
	Patterns : "Patterns",
	Firmware : "Firmware",
	ShowUpdates : "Show Updates",
	Discover : "Discover",
	DeployComputeNodeImages : "Deploy Server Images",
	DeployVirtualAppliance : "Deploy Virtual Appliance",
	Monitor : "Monitor",
	Status : "Status",
	ActiveStatus : "Active Status",
	EventHistory : "Event Log",
	ServiceProblems : "Service Problems",
	Monitoring : "Monitoring",
	Monitors : "Monitors",
	Thresholds : "Thresholds",
	Compliance : "Compliance",
	MonitoredSystems : "Monitored Systems",
	Policies : "Policies",
	Automation : "Automation",
	Plans : "Plans",
	Actions : "Actions",
	EventFilters : "Event Filters",
	CommandDefinitions : "Command Definitions",
	Jobs : "Jobs",
	ActiveAndScheduledJobs : "Active and Scheduled Jobs",
	CreateAutomationPlan : "Create Automation Plan",
	Security : "Security",
	Permissions : "Permissions",
	UsersAndGroups : "Users and Groups",
	Roles : "Roles",
	Credentials : "Credentials",
	Access : "Access",
	SystemsWithNoAccess : "Systems With No Access",
	Auditing : "Auditing",
	AuditLog : "Audit Log",
	ChangePassword : "Change Password",
	CreateUser : "Create User",
	Utilities : "Utilities",
	Settings : "Settings",
	AutoRename : "Auto-Rename",
	ServiceandSupport : "Service and Support",
	ServerAuditing : "Server Auditing",
	Administration : "Administration",
	FSMSettings : "IBM&reg; FSM Settings",
	Plugins : "Plug-ins",
	ApplicationExtensions : "Applications",
	UserPreferences : "User Preferences",
	EventLog : "Event Log",
	ManagementServer : "Management Server",
	NetworkManagement : "Network Management",
	BackupAppliance : "Back Up IBM&reg; FSM",
	HelpMenu : "Help",
	IntroductionToIBMFlexExplorer : "Introduction to IBM&reg; FSM Explorer",
	FindingTasksInIBMFlexExplorer : "Finding tasks in IBM&reg; FSM Explorer",
	Help : "Help",
	About : "About",
	IBMSupport : "IBM&reg; Support",
	LiCTooltip : "Opens in {0}",
	Signout : "Sign Out",

	//General dialog labels
	OK : "OK",
	CANCEL : "Cancel",
	SUBMIT : "Submit",
        YES    : "Yes",
        NO     : "No",
	
	//Popup blocker warning
	PopupBlockerWarning : "The pop-up blocker is enabled for this site. Disable the browser pop-up blocker for this site and try again.",
	
	//ISC launched in tab pages warning
	LaunchedInTabs1 : "The {0} task that you launched is in a browser tab that is hidden behind other tabs.",
	LaunchedInTabs2 : "To work with the task, select the tab or move the tab into its own window. To avoid this situation in the future, use a separate browser window for {0}.",
	InvalidUser : "User {0} is unknown. If the server is starting, try again in a few minutes.",
		
	UserNotAuthorized : "The user is not authorized to the content on this page.",
	UserNotAuthorizedDescription: "Ensure a user role with adequate permissions is assigned to the user.  At a minimum, the Group Read and Resource Explorer permissions are required to view pages.",
	
	HybridDataset: "{0} items are in the group. {1} have been filtered, but only the first {2} are shown.",
	HybridDatasetDescription: "Use search and filter to narrow your results.",
	HybridSummaryCounts: "Total: {0}  Filtered: {1}  Available: {2}  Selected: {3}"
    },

    "de": true,
    "zh-tw": true,
    "ko": true,
    "ja": true,
    "en": true,
    "it": true,
    "pt-br": true,
    "fr": true,
    "zh-cn": true,
    "es": true
});