/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/*global define */
define("ibm/usmi/scheduler/wizard_pages/nls/zh-cn/JobLaunchWizardResources", {
	/**
	 * This file contains resources for each page of the job launch wizard.
	 * Please keep overall Job Launch Wizard resources in the first section of
	 * the file. The second section contains resources for the Schedule page.
	 * The third section contains resources for the Notifications page. The
	 * fourth section contains resources for the Options page.
	 */

	/**
	 * Section 1: Overall Job Launch Wizard resources.
	 */
	// Messages:
	JOB_SUCCESSFULLY_RUN_NOW : "已成功创建并启动以下作业：",
	JOB_SUCCESSFULLY_SCHEDULED : "已成功创建并调度以下作业：",
	JOB_CREATION_FAILED : "创建新作业失败。",
	JOB_FAILED_RESPONSE : "如果问题仍然存在，请与支持人员联系。",
	// The following error message should never be displayed to the user.  There 
	// are no scenarios where this message should ever needed
	// However, if a bug exists in the code, this message can be used so that
	// the UI does not crash (and give no reason to the user why the UI did not function
	// as expected).  Currently logging is not defined...When logging is defined and working, 
	// the code is obligated to log additional information (when available) before issuing
	// this message.
	GENERIC_ERROR_MESSAGE : "尝试启动任务时发生问题。",
	GENERIC_ERROR_RESPONSE : "如果问题仍然存在，请与上一级支持机构或服务代表联系。",
	
	// Field labels:
	SUBMIT_BUTTON_LABEL : "提交",
			
	// Completion Message link text
	VIEW_JOB_LINK_TEXT : "查看作业",

	/**
	 * Section 2: Resources for the Schedule Page of the Job Launch Wizard.
	 */
	// Page title:
	SCHEDULE_PAGE_TITLE : "调度",

	// Messages:
	NO_VALID_JOB_NAME_ERROR : "为作业名输入的值无效。",
	MISSING_CUSTOM_DATES : "未选择任何定制日期。",
	SELECTED_DATE_IN_PAST : "当前选择的日期和时间已过或是当时。",
	REPEAT_FOR_DURATION_NOT_VALID : "选择介于 1 和 5000 之间的“重复时长”持续时间值。",
	REPEAT_UNTIL_DURATION_NOT_VALID : "“重复截止”持续时间值在调度的日期之前。",
	MISSING_SELECTED_DAY_OF_WEEK : "未选择星期几。",
	MISSING_MONTHLY_DATES : "未选择每月日期。",
	CUSTOM_DATE_ALREADY_SELECTED : "选择的定制日期已在列表中。请选择另一个日期。",
	CUSTOM_DATE_IN_PAST : "选择的日期已过或是当时。请选择另一个日期。",
	MONTHLY_DATE_ALREADY_SELECTED : "选择的每月日期已在列表中。请选择另一个日期。",

	// Field labels:
	WHEN_TO_RUN_LABEL : "运行时间：",
	JOB_NAME_LABEL : "作业名：",
	SCHEDULE_DATE_LABEL : "日期：",
	SCHEDULE_TIME_LABEL : "时间：",
	REPEATE_OPTIONS_LABEL : "重复选项：",
	FREQUENCY_LABEL : "频率：",
	WEEKEND_LABEL : "在周末：",
	WEEKLY_VALUES_LABEL : "每周在以下日子运行：",
	MONTHLY_SELECT_LABEL : "每月在以下日期运行：",
	CUSTOM_DATES_ADD_VALUES_PROMPT : "单击“添加”以将以上日期添加至下面的已安排日期列表。",
	DURATION_LABEL : "持续时间：",
	REPEAT_OPTIONS_LABEL : "重复选项：",
	REPEAT_FOR_VALUE_LABEL : "重复时长：",
	REPEAT_UNTIL_VALUE_LABEL : "重复截止：",
	REPEAT_FOREVER_PROMPT : "无限制",
	REPEAT_FOR_PROMPT : "对于",
	REPEAT_UNTIL_PROMPT : "直到",
	ADD_BUTTON_LABEL : "添加",
	REMOVE_BUTTON_LABEL : "除去",

	// Field values:
	RUN_NOW_VALUE : "立即运行",
	RUN_LATER_VALUE : "调度",
	REPEAT_FOREVER_VALUE : "永远重复",
	REPEAT_SELECTION_ONCE_VALUE : "一次",
	REPEAT_SELECTION_HOURLY_VALUE : "每小时",
	REPEAT_SELECTION_DAILY_VALUE : "每天",
	REPEAT_SELECTION_WEEKLY_VALUE : "每周",
	REPEAT_SELECTION_MONTHLY_VALUE : "每月",
	REPEAT_SELECTION_YEARLY_VALUE : "每年",
	REPEAT_SELECTION_CUSTOM_VALUE : "定制",
	WEEKEND_DONT_MOVE_VALUE : "不移动",
	WEEKEND_MOVE_TO_FRIDAY_VALUE : "移动到星期五",
	WEEKEND_MOVE_TO_MONDAY_VALUE : "移动到星期一",
	WEEKEND_MOVE_TO_WEEKDAY_VALUE : "移动到最近的工作日",
	WEEKEND_DELETE_VALUE : "删除",
	WEEKLY_SUNDAY_VALUE : "星期日",
	WEEKLY_MONDAY_VALUE : "星期一",
	WEEKLY_TUESDAY_VALUE : "星期二",
	WEEKLY_WEDNESDAY_VALUE : "星期三",
	WEEKLY_THURSDAY_VALUE : "星期四",
	WEEKLY_FRIDAY_VALUE : "星期五",
	WEEKLY_SATURDAY_VALUE : "星期六",

	MONTHLY_DATE_1ST_VALUE : "1 号",
	MONTHLY_DATE_2ND_VALUE : "2 号",
	MONTHLY_DATE_3RD_VALUE : "3 号",
	MONTHLY_DATE_4TH_VALUE : "4 号",
	MONTHLY_DATE_5TH_VALUE : "5 号",
	MONTHLY_DATE_6TH_VALUE : "6 号",
	MONTHLY_DATE_7TH_VALUE : "7 号",
	MONTHLY_DATE_8TH_VALUE : "8 号",
	MONTHLY_DATE_9TH_VALUE : "9 号",
	MONTHLY_DATE_10TH_VALUE : "10 号",
	MONTHLY_DATE_11TH_VALUE : "11 号",
	MONTHLY_DATE_12TH_VALUE : "12 号",
	MONTHLY_DATE_13TH_VALUE : "13 号",
	MONTHLY_DATE_14TH_VALUE : "14 号",
	MONTHLY_DATE_15TH_VALUE : "15 号",
	MONTHLY_DATE_16TH_VALUE : "16 号",
	MONTHLY_DATE_17TH_VALUE : "17 号",
	MONTHLY_DATE_18TH_VALUE : "18 号",
	MONTHLY_DATE_19TH_VALUE : "19 号",
	MONTHLY_DATE_20TH_VALUE : "20 号",
	MONTHLY_DATE_21ST_VALUE : "21 号",
	MONTHLY_DATE_22ND_VALUE : "22 号",
	MONTHLY_DATE_23RD_VALUE : "23 号",
	MONTHLY_DATE_24TH_VALUE : "24 号",
	MONTHLY_DATE_25TH_VALUE : "25 号",
	MONTHLY_DATE_26TH_VALUE : "26 号",
	MONTHLY_DATE_27TH_VALUE : "27 号",
	MONTHLY_DATE_28TH_VALUE : "28 号",
	MONTHLY_DATE_29TH_VALUE : "29 号",
	MONTHLY_DATE_30TH_VALUE : "30 号",
	MONTHLY_DATE_31ST_VALUE : "31 号",

	REPEAT_FOR_HOURS_VALUE : "小时",
	REPEAT_FOR_DAYS_VALUE : "天",
	REPEAT_FOR_WEEKS_VALUE : "周",
	REPEAT_FOR_MONTHS_VALUE : "月",
	REPEAT_FOR_YEARS_VALUE : "年",

	/**
	 * Section 3: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	NOTIFICATIONS_PAGE_TITLE : "通知",

	// Messages:
	PERCENT_FAILED_VALUE_NOT_SET_ERROR : "选择介于 1 和 100 之间的失败目标百分比。",
	NUMBER_FAILED_VALUE_NOT_SET_ERROR : "选择大于 0 的失败目标数。",
	MISSING_EMAIL_INFORMATION : "请确保已经为所有电子邮件字段输入信息。",
	EMAIL_ADDRESS_WRONG_FORMAT : "电子邮件地址格式错误",

	// Field labels:
	RECEIVE_NOTIFICATIONS_LABEL : "接收通知：",
	JOB_FAILS_ANY_ERROR_RADIO_LABEL : "任何错误",
	JOB_FAILS_PERCENT_ERROR_RADIO_LABEL : "有错误的目标的百分比：",
	JOB_FAILS_NUMBER_ERROR_RADIO_LABEL : "有错误的目标数：",
	EMAIL_INFORMATION_LABEL : "电子邮件信息：",
	EMAIL_ADDRESS_LABEL : "电子邮件地址：",
	EMAIL_SERVER_LABEL : "电子邮件服务器名称：",
	EMAIL_PORT_LABEL : "电子邮件服务器端口号：",

	// Field values:
	JOB_BEGINS_VALUE : "在此作业开始时通知。",
	JOB_COMPLETES_OK_VALUE : "在此作业成功完成时通知。",
	JOB_FAILS_VALUE : "在此作业失败时通知。",

	/**
	 * Section 4: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	OPTIONS_PAGE_TITLE : "选项",

	// Messages:
	MAXIMUM_JOB_INSTANCES_VALUE_ERROR : "选择介于 10 和 100 之间的作业实例的最大数目。",

	// Field labels:
	SYSTEM_TIMES_LABEL : "系统时间：",
	UNAVAILABLE_SYSTEMS_LABEL : "不可用系统：",
	MAXIMUM_JOBS_LABEL : "最大作业实例数：",
	MANAGEMENT_SERVER_TIME_RADIO : "使用管理服务器时间",
	LOCAL_SYSTEM_TIME_RADIO : "使用本地系统时间",
	FAIL_IF_UNAVAILABLE_RADIO : "在系统不可用时放弃",
	RUN_WHEN_AVAILABLE_RADIO : "在系统可用时运行"
});

