/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/statuspod/StatusPodMenuDialog", [
    "dojo/_base/kernel",
    "dojo/_base/declare",
    "idx/oneui/MenuDialog",
    "ibm/usmi/core/utils/Logger"
], function(dojo, declare, MenuDialog, Logger) {
    return declare([ MenuDialog
    ], {
        // summary:
        //      MenuDialog for the status pod

        _logger: new Logger("ibm.usmi.statuspod", "StatusPodMenuDialog"),

        onClose: function() {
            // summary:
            //      the callback method to close menu dialog
            this.inherited(arguments);
            this._logger.finest("menu dialog is on closing!", "onClose");
            if (this.content.closeDescendants) {
                this.content.closeDescendants();
            }
        }

    });
});
