require({cache:{
'url:ibm/usmi/widgets/templates/TaskLink.html':"<a class=\"taskLink taskLinkAnchor\" data-dojo-attach-point=\"taskAnchor\" role=\"link\">\r\n<!--\r\n<a class=\"taskLink taskLinkAnchor\" data-dojo-attach-point=\"taskAnchor\" role=\"link\" href=\"#${link}\">\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div class=\"taskLink-iehack\">\r\n\t    <div class=\"taskLinkLabelContainer\">\r\n<!-- \t\t      <div class=\"taskLinkIcon sprite\" data-dojo-attach-point=\"iconPoint\"></div> -->\r\n\t\t      <img class=\"taskLinkIcon sprite\" data-dojo-attach-point=\"iconPoint\"></img>\r\n\t\t      <div class=\"taskLinkLabel\" data-dojo-attach-point=\"labelPoint\"></div>\r\n\t\t</div>\r\n\t\t<div class=\"taskLinkStatusIcon right sprite\" data-dojo-attach-point=\"statusIconPoint\"></div>\r\n\t</div>\t\r\n</a>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/TaskLink", [
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dojo/topic",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/TaskLink.html",
	"dijit/_Contained",
	"dijit/focus",
	// NextGen imports
	"ibm/usmi/util/BaseWidget",
	"ibm/usmi/widgets/util/TextAbbr",
	"ibm/usmi/widgets/util/Constants",
	"ibm/usmi/core/utils/Logger"
], function (dojo, declare, topic, _WidgetBase, _TemplatedMixin, TaskLinkTemplate, _Contained, focus, BaseWidget,
		TextAbbr, Constants, Logger) {

	return declare([
		_WidgetBase,
		_TemplatedMixin,
		_Contained,
		BaseWidget
	], {

		// Template info
		templateString : TaskLinkTemplate,

		/**
		 * NLS translated label for this link which the user will see
		 * 
		 * @param
		 */
		label : "",

		resourceLabel : "",

		criteriaString : "",

		path : "",

		pathKey : "",

		/**
		 * CSS class name of a 16x16 pixel icon to display by this link
		 * 
		 * @param
		 */
		icon : "",

		// path to where the icons are located
		iconPath : "",

		/**
		 * unique identifier for this link which will be sent out in the
		 * topic.publish when the link is pressed
		 * 
		 * @param
		 */
		link : "",

		/**
		 * unique in conjunction with the link which will be sent out in the
		 * topic.publish when the link is pressed
		 * 
		 * @param
		 */
		taskId : "",

		/**
		 * Type of task launch
		 * 
		 * @param
		 */
		type : "",

		/*
		 * Map TabIndex to the taskAnchor node so this widget can be managed by _KeyNavContainers
		 */
		attributeMap : dojo.delegate(_WidgetBase.prototype.attributeMap, {
			tabIndex : "taskAnchor"
		}),

		/**
		 * Default status of the link: normal, error, warning etc.
		 * 
		 * @public
		 */
		status : "normal",

		/**
		 * Default count displayed next to the link: (5)
		 * 
		 * @public
		 */
		count : null,

		textAbbr : null,

		/**
		 * Whether this link will attempt to pre-select itself when initialzied.
		 * Only one link can be selected at a time but multiple can try... only
		 * one will succeed. Use with care
		 * 
		 * @public
		 */
		selected : false,
		show : true, //false for dynamic task links
		
		wasClicked: false,

		// the logger
		_taskLinkLogger : new Logger("ibm.usmi.widgets", "TaskLink"),

		postCreate : function () {
			this.inherited(arguments);
			this.connect(this.taskAnchor, Constants.ON_CLICK, this._handleClick);
		},

		startup : function () {
			this.inherited(arguments);
			
			// check to see if task selection is set
			if (this.getUrlHashParm(Constants.HASH_TASK_SELECTION)) {
				// check to see what type of link was bookmarked if any
				if (this.type.toUpperCase() === Constants.TASK_TYPE_RELATED_RESOURCE) {
					// since type is related resource, taskSeelction for all related resources
					// is relatedResource, need to look at RELATIONSHIP has value
					if (this.getUrlHashParm(Constants.HASH_TASK_RELATIONSHIP) === this.taskId) {
						this.selected = true;
					}
				} else {
					// check the task selection equal to taskID
					if (this.getUrlHashParm(Constants.HASH_TASK_SELECTION) === this.taskId) {
						this.selected = true;
					}
				}
				
			}	
			
			// fire off the update
			this.update();
		},

		buildRendering : function () {
			this.inherited(arguments);
		},

		update : function (args) {
			dojo.mixin(this, args);
			dojo.toggleClass(this.taskAnchor, "hidden", !this.show);
			this.updateLabel(); // do this unconditionally to add content to the anchor else live validators complain e.g. RPT
			if (this.show) {
				this.updateIcon();
				this.updateStatusIcon();
				this.selectionCheck();
			}
		},

		select : function (select) {
			this.selected = select;
			//fix defect 24146: focus != seclect in L3 page
			//when link is selected by url anchor (dojo.hash)
			if (select && (this.getUrlHashParm(Constants.HASH_TASK_SELECTION) === this.taskId)) {
				var node = this.domNode, focusedArray = dojo.query(node.tagName + ":focus", this.getParent()
						.getParent().domNode);
				//focus on one link but not me, then change focus to me.
				if (focusedArray.length > 0 && focusedArray[0] !== node) {
					node.focus();
				}
			}
			dojo.toggleClass(this.domNode, "taskLink-selected", select);
		},

		selectionCheck : function () {
			if (this.selected) {
				this.getParent().getParent()._linkClicked("selfSelect", this);
				this._handleClick();
			}
		},

		updateIcon : function () {
			//dojo.removeClass(this.iconPoint);
			// dojo.addClass(this.iconPoint, ["taskLinkIcon", "sprite", this.icon]);
			dojo.attr(this.iconPoint, "src", this.iconPath + this.icon);

		},

		updateLabel : function () {
			var formattedLabel = this.label;

			//update the textAbbr if it exists
			if (this.textAbbr) {
				this.textAbbr.update(formattedLabel);
			} else {//create textAbbr
				this.textAbbr = new TextAbbr({
					text : formattedLabel,
					maxLength : 34,
					format : " (x)"
				}, this.labelPoint);
			}
		},

		updateStatusIcon : function () {
			var domNode = this.statusIconPoint, icons = [
				"errorIcon",
				"warningIcon",
				"unknownIcon"
			], lookup = {
				"error" : {
					iconClass : "errorIcon",
					altText : "(X)"
				},
				"warning" : {
					iconClass : "warningIcon",
					altText : "(!)"
				},
				"unknown" : {
					iconClass : "unknownIcon",
					altText : "(?)"
				},
				"normal" : {
					iconClass : "",
					altText : ""
				}
			}, statusObject = lookup[this.status] || lookup.normal;

			dojo.removeClass(domNode, dojo.filter(icons, function (icon) {
				return icon !== statusObject.iconClass;
			}));
			dojo.addClass(domNode, statusObject.iconClass);
			if (dojo.hasClass(dojo.body(), "dijit_a11y")) {
				dojo.create("span", {
					innerHTML : statusObject.altText
				}, domNode, "only");
			}
		},

		/*
		 * Simulate _FormWidget functions so this widget can be managed by _KeyNavContainers
		 */
		isFocusable : function () {
			return !this.disabled && (dojo.style(this.domNode, "display") !== "none");
		},

		focus : function () {
			focus.focus(this.taskAnchor);
		},

		getLabel : function () {
			return this.label;
		},

		getResourceLabel : function () {
			return this.resourceLabel;
		},

		getCriteriaString : function () {
			return this.criteriaString;
		},

		getPath : function () {
			return this.path;
		},

		getPathKey : function () {
			return this.pathKey;
		},
		
		getWasClicked : function () {
			return this.wasClicked;
		},
		
		resetWasClicked : function () {
			this.wasClicked = false;
		},

		_handleClick : function (evt) {
			if (this._taskLinkLogger.isFinest()) {
				this._taskLinkLogger.entering("", "_handleClick");
			}
			var obj, launchParms, targetInfo;
			
			this.wasClicked = true;
			// if task type is widget, hash the link
			if (this.type.toUpperCase() === Constants.TASK_TYPE_WIDGET) {
				if (this._taskLinkLogger.isFiner()) {
					this._taskLinkLogger.finer(this.link, "_handleClick");
				}
				obj = dojo.queryToObject(this.link);
				
				// remove the RELATIONSHIP hashkey if there
				if(obj['relationship']) {
					delete obj.relationship;
				}
				
				//if path specified, set it to be included in hash
				if (this.path && this.pathKey) {
					obj.taskPath = this.path;
					obj.taskPathKey = this.pathKey;
				}
				dojo.hash(dojo.objectToQuery(obj), true); // set
				targetInfo = {
					sourceToken : this.sourceToken,
					taskSelection : obj.taskSelection,
					taskPath : this.path,
					taskPathKey : this.pathKey
				};
				topic.publish(Constants.TOPIC_RETARGET_INFO, targetInfo); //tell WorkArea the new info

			} else if (this.type.toUpperCase() === Constants.TASK_TYPE_RELATED_RESOURCE) {
				if (this._taskLinkLogger.isFiner()) {
					this._taskLinkLogger.finer(this.link, "_handleClick");
				}
				obj = dojo.queryToObject(this.link);
				obj.relationship = this.criteriaString;
				dojo.hash(dojo.objectToQuery(obj), true); // set
				targetInfo = {
					relationship : this.criteriaString,
					sourceToken : this.sourceToken,
					taskSelection : obj.taskSelection
				};
				topic.publish(Constants.TOPIC_RETARGET_INFO, targetInfo); //tell RRTable the new info

			}
			// if is URL, publish the URL
			else if (this.type.toUpperCase() === Constants.TASK_TYPE_URL) {
				launchParms = {
					topic : Constants.TOPIC_DEFAULT_URL_LAUNCH,
					launchType : Constants.TASK_TYPE_URL,
					urlToLaunch : this.link
				};

				topic.publish(Constants.TOPIC_DEFAULT_URL_LAUNCH, launchParms);
			}

			if (this._taskLinkLogger.isFinest()) {
				this._taskLinkLogger.exiting("", "_handleClick");
			}
		},
		
		fakeClick : function () {
			if (this._taskLinkLogger.isFinest()) {
				this._taskLinkLogger.entering("", "fakeClick");
			}
			var obj, launchParms, targetInfo;
			
			// if task type is widget, hash the link
			if (this.type.toUpperCase() === Constants.TASK_TYPE_WIDGET) {
				if (this._taskLinkLogger.isFiner()) {
					this._taskLinkLogger.finer(this.link, "fakeClick");
				}
				obj = dojo.queryToObject(this.link);
				targetInfo = {
					sourceToken : this.sourceToken,
					taskSelection : obj.taskSelection,
					taskPath : this.path,
					taskPathKey : this.pathKey
				};
				topic.publish(Constants.TOPIC_RETARGET_INFO, targetInfo); //tell WorkArea the new info

			} else if (this.type.toUpperCase() === Constants.TASK_TYPE_RELATED_RESOURCE) {
				if (this._taskLinkLogger.isFiner()) {
					this._taskLinkLogger.finer(this.link, "fakeClick");
				}
				obj = dojo.queryToObject(this.link);
				targetInfo = {
					relationship : this.criteriaString,
					sourceToken : this.sourceToken,
					taskSelection : obj.taskSelection
				};
				topic.publish(Constants.TOPIC_RETARGET_INFO, targetInfo); //tell RRTable the new info

			}
			// if is URL, publish the URL
			else if (this.type.toUpperCase() === Constants.TASK_TYPE_URL) {
				launchParms = {
					topic : Constants.TOPIC_DEFAULT_URL_LAUNCH,
					launchType : Constants.TASK_TYPE_URL,
					urlToLaunch : this.link
				};

				topic.publish(Constants.TOPIC_DEFAULT_URL_LAUNCH, launchParms);
			}

			if (this._taskLinkLogger.isFinest()) {
				this._taskLinkLogger.exiting("", "_handleClick");
			}			
		},
		
		destroy : function () {
			if (this.textAbbr) {
				this.textAbbr.destroy();
			}
			this.inherited(arguments);
		}
	});
});