require({cache:{
'url:ibm/usmi/widgets/templates/TreeTopper.html':"<div data-dojo-attach-point=\"mainNode\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div class=\"treeTopperCategoryBar\">\r\n\t   <div class=\"treeTopperCategoryTitle\" data-dojo-attach-point=\"titlePoint\" role=\"heading\" aria-level=2 ></div>\r\n\t</div>\r\n\t<div class=\"treeTopper\" data-dojo-attach-point=\"containerNode\"></div>\r\n</div>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/TreeTopper", ["dojo/_base/kernel",
        "dojo/_base/declare",
        "dijit/_WidgetBase",
        "dijit/_TemplatedMixin",
        "dojo/topic",
        "dojo/text!./templates/TreeTopper.html",
        "dijit/_KeyNavContainer",
        "dijit/_Contained",
        // NextGen imports
        "ibm/usmi/widgets/TreeTopperLinks",
        "ibm/usmi/widgets/util/Constants"],
    function (dojo, declare, _WidgetBase, _TemplatedMixin, topic, TreeTopperTemplate, _KeyNavContainer, _Contained,
            TreeTopperLinks, Constants) {

    return declare([_WidgetBase, _TemplatedMixin, _KeyNavContainer, _Contained], {

        // Template info
        templateString: TreeTopperTemplate,

        // topper label
        label: "",

        // topper links
        _links : [],

        //Subscriptions to clean up
        _subscriptions : null,
		
		// workarea is ready
		_workAreaReady : false,

        constructor: function() {
			this._subscriptions = [];
			
            // listen for when Tree is in charge, and unselecto tree topper selection
            this._subscriptions.push(topic.subscribe("TREEINCHARGE", dojo.hitch(this, this.removeSelection)));
			
			// subscribe to workarea isReady event
 //           this._subscriptions.push(topic.subscribe(Constants.TOPIC_READY_WORKAREA, dojo.hitch(this, this.workAreaIsActive)));
			
			// subscrib to hash updates
			this._subscriptions.push(topic.subscribe(Constants.TOPIC_HASH_CHANGE, dojo.hitch(this, this._hashChanged)));
        },

        startup: function() {
            this.inherited(arguments);

            // initialize array
            this._links = [];

            // key nav container
            this.startupKeyNavChildren();
  
        },

        postCreate: function() {
            this.inherited(arguments);

            // key nav container
            this.connectKeyNavHandlers([dojo.keys.UP_ARROW],[dojo.keys.DOWN_ARROW]);
        },

        buildRendering: function() {
            this.inherited(arguments);
            this.titlePoint.innerHTML = this.label;
        },

        addTreeTopperLink: function(tLink) {
            this.addChild(tLink);
            this._links.push(tLink);
        },

        /*
         * Returns TreeTopperLinks widget.
         */
        getRoot: function(/*String*/ id) {
            var subset = dojo.filter(this.getChildren(), function(/*Widget*/ child) {
                return child.isInstanceOf(TreeTopperLinks) && child.rootId === id;
            }, this);
            return (subset && subset[0]) || null;
        },

        removeLink: function(/*String*/id) {
            var widget = this.getRoot(id);
            if(widget) {
                this.removeChild(widget);
            }
        },

        setLink: function(/*ibm.usmi.widgets.TreeTopperLinks*/link) {
            dojo.forEach(this.getChildren(), function(item) {
                item.select(false);
            });
            link.select(true);
        },

        removeSelection: function() {
            dojo.forEach(this.getChildren(), function(item) {
                if(item) {
                    item.select(false);
                }
            });
        },

        _hashChanged : function (/*dojo.hash*/hash) {
            dojo.forEach(this._links, function (link) {
                if (this.getUrlHashParm(ibm.usmi.widgets.util.Constants.HASH_TOPPER_SELECTION) === link.topperId) {
                    this.setLink(link);
                }
            }, this);
        },


        // workAreaIsActive : function () {
		//	when tree topper link is bookmarked or direct launched it publish retarget event before workArea is ready
			// dojo.forEach(this.getChildren(), function(item) {
				// if(item.selected) {
					// item._handClick();
				// }
            // });
			// this._workAreaReady = true;
        // },

        destroy : function () {
            var idx = 0;
            for (; idx < this._subscriptions.length; idx++) {
                this._subscriptions[idx].remove();
            }
            this._subscriptions.length = 0;
            this.inherited(arguments);
        }

    });
});