/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/finder/FinderSearchDialog", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/i18n!ibm/usmi/nls/frameworkResources",
	"dojo/dom-construct",
	"dijit/TooltipDialog"
], function (declare, lang, MRI, domConstruct, TooltipDialog) {
	return declare([ TooltipDialog
	], {
		refreshImage : null,
		finderWidget : null,
		initialize : function () {
			domConstruct.empty(this.containerNode);
			domConstruct.create("img", {
				onclick : lang.hitch(this.finderWidget, this.finderWidget.closeSearchDetailDlg),
				src : "js/ibm/usmi/core/framework/themes/images/title_close.gif",
				title : MRI.Close,
				alt : MRI.Close,
				className : "closeImg"
			}, this.containerNode);

			this.refreshImage = domConstruct.create("img", {
				onclick : lang.hitch(this.finderWidget, this.finderWidget._manualRefresh),
				src : "js/ibm/usmi/core/framework/themes/images/ac16_refresh.png",
				alt : MRI.FinderRefreshing,
				className : "refreshImg"
			}, this.containerNode);
			this.changeRefreshCount();
			domConstruct.create("span", {
				id : "finderfinderMenu",
				style : "display:inline;"
			}, this.containerNode);

		},
		changeRefreshCount : function () {
			this.refreshImage.title = lang.replace(MRI.RefreshCache, [
				this.lastRefresh,
				MRI.Minutes
			]);
		},
		searching : function (stateNumber) {
			domConstruct.create("div", {
				id : 'searchingText',
				innerHTML : MRI['Searching' + stateNumber]
			}, this.containerNode);
		}

	});
});
