/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/util/DefaultContextMenuProvider", ["dojo/_base/kernel",
        "dojo/_base/declare",
        // TWL imports
        "ibm/tivoli/tip/navwidget/dijit/RESTContextMenuProvider",
        "ibm/tivoli/navmodel/Selection",
        "ibm/usmi/widgets/util/Constants"],
    function (dojo, declare, RESTContextMenuProvider, Selection, Constants) {

    return declare([RESTContextMenuProvider], {

        // summary:
        //        Coming soon
        // description:
        //        Coming soon

        // _handle:
        //
        _handle: null,

        filterNavigationTasks: function(/*ibm.tivoli.navmodel.Task[]*/ tasks) {
            // summary:
            //    Return a filtered collection of tasks
            //    Filter out related resources (parent has id RELATED_RESOURCES,
            //       children have id RELATIONSHIP:*
            //    Filter out related resources (parent has id PERSPECTIVES,
            //       children have id PERSPECTIVE:*
            //    Note:  Separators have no task id.
            //
            var filteredTasks = [];
            for (var i = 0; i < tasks.length; i++) {
                if ((tasks[i].getId() === undefined) ||
                    ((tasks[i].getId() !== "RELATED_RESOURCES") &&
                    (tasks[i].getId().indexOf("RELATIONSHIP:") !== 0) &&
                    (tasks[i].getId() !== "PERSPECTIVES") &&
                    (tasks[i].getId().indexOf("PERSPECTIVE:") !== 0) &&
                    (tasks[i].getId() !== "VIEW_MEMBERS"))) {
                    filteredTasks.push(tasks[i]);
                }
            } 
            return filteredTasks;
        },

        handleNavigation: function(data, ioArgs) {
            // summary:
            //        Coming soon
            // description:
            //        Coming soon
            // data:
            //
            // ioArgs:
            //

            // listen for event indicating new dataset is loaded and dismiss the busy pane
            this._handle = dojo.connect(this.view, Constants.SET_DATASET, this, function(dataset) {
                                                                                //this.view.hideBusyPane();
                                                                                dojo.disconnect(this._handle);});
        //    this.view.showBusyPane();
            this.view.getCurrentDataset().navigate(
                    {onComplete: dojo.hitch(this, this._processNavNewDataSet),
                    onError: dojo.hitch(this, this._handleNavNewDataSetError),
                    taskId: data.actionID,
                    taskCategory: data.category,
                    selection: this.buildClientNavModelSelection(data, this.view.dataset.getVersion())});
        },

        _processNavNewDataSet: function(dataset, kwArgs) {
            // summary:
            //        Coming soon
            // description:
            //        Coming soon
            // dataset:
            //
            // kwArgs:
            //
            this.view.addDataset(dataset);
        //    this.view.hideBusyPane();
        },

        _handleNavNewDataSetError: function(error, exception, ioArgs) {
            // summary:
            //        Coming soon
            // description:
            //        Coming soon
            // error:
            //
            // exception:
            //
            // ioArgs:
            //

            // in case of an error, dismiss the busy pane
    //        this.view.hideBusyPane();
            dojo.disconnect(this._handle);

            //Give the user some feedback
            this.view.displayException(error);
        }

    });
});